Lorene::Metric_flat Class Reference
Tensorial fields

Flat metric for tensor calculation. More...

`#include <metric.h>`

Inheritance diagram for Lorene::Metric_flat:

## Public Member Functions

| Metric_flat (const Map &, const Base_vect &)
| Standard constructor.
| Metric_flat (const Metric_flat &)
| Copy constructor.
| Metric_flat (const Map &, FILE *)
| Constructor from a file (see `sauve(FILE*)` ).
virtual | ~Metric_flat ()
| Destructor.
void | operator= (const Metric_flat &)
| Assignment to another Metric_flat.
virtual void | operator= (const Sym_tensor &tens)
| Assignment from a `Sym_tensor` .
const Base_vect * | get_triad () const
| Returns the vectorial basis (triad) on which the metric is defined.
virtual const Sym_tensor & | cov () const
| Read-only access to the covariant representation.
virtual const Sym_tensor & | con () const
| Read-only access to the contravariant representation.
virtual const Connection & | connect () const
| Returns the connection.
virtual const Scalar & | ricci_scal () const
| Returns the Ricci scalar.
virtual const Scalar & | determinant () const
| Returns the determinant.
virtual void | sauve (FILE *) const
| Save in a file.
const Map & | get_mp () const
| Returns the mapping.
const Sym_tensor & | ricci () const
| Returns the Ricci tensor (given by the `Connection` `p_connect` ).
virtual const Vector & | radial_vect () const
| Returns the radial vector normal to a spherical slicing and pointing toward spatial infinity.

## Protected Member Functions

virtual ostream & | operator>> (ostream &) const
| Operator >> (virtual function called by the operator <<).
void | del_deriv () const
| Deletes all the derived quantities.
void | set_der_0x0 () const
| Sets to `0x0` all the pointers on derived quantities.
void | del_tensor_depend () const
| Deletes all the derivative members of the `Tensor` contained in `tensor_depend` .
void | set_tensor_depend_0x0 () const
| Sets all elements of `tensor_depend` to 0x0.

## Protected Attributes

const Base_vect * | triad
| Vectorial basis (triad) with respect to which the components of the flat metric are defined.
const Map *const | mp
| Reference mapping.
Sym_tensor * | p_met_cov
| Pointer on the contravariant representation.
Sym_tensor * | p_met_con
| Pointer on the covariant representation.
Connection * | p_connect
| Connection associated with the metric.
Scalar * | p_ricci_scal
| Pointer on the Ricci scalar.
Vector * | p_radial_vect
| Pointer to the radial vector normal to a spherical slicing and pointing toward spatial infinity.
Scalar * | p_determinant
| Pointer on the determinant.
const Tensor * | tensor_depend [N_TENSOR_DEPEND]
| Pointer on the dependancies, that means the array contains pointers on all the `Tensor` whom derivative members have been calculated using `*this` .

## Detailed Description

Flat metric for tensor calculation.

()

Definition at line 261 of file metric.h.

## Constructor & Destructor Documentation

## Metric_flat() [1/3]

Lorene::Metric_flat::Metric_flat | ( | const Map & | mpi,
|  | const Base_vect & | triadi )

Standard constructor.

Standard constructor from a mapping and a triad.

Definition at line 76 of file metric_flat.C.

References cov(), Lorene::Map(), Lorene::Metric::Metric(), and triad.

## Metric_flat() [2/3]

Lorene::Metric_flat::Metric_flat | ( | const Metric_flat & | meti | ) |

Copy constructor.

Definition at line 85 of file metric_flat.C.

References Lorene::Metric::Metric(), Metric_flat(), and triad.

## Metric_flat() [3/3]

Lorene::Metric_flat::Metric_flat | ( | const Map & | mpi,
|  | FILE * | fd )

Constructor from a file (see `sauve(FILE*)` ).

Definition at line 91 of file metric_flat.C.

References Lorene::Map(), and Lorene::Metric::Metric().

## ~Metric_flat()

Lorene::Metric_flat::~Metric_flat | ( |  | ) |

virtual

Destructor.

Definition at line 103 of file metric_flat.C.

## Member Function Documentation

## con()

const Sym_tensor & Lorene::Metric_flat::con | ( |  | ) | const

virtual

Read-only access to the contravariant representation.

Reimplemented from Lorene::Metric.

Definition at line 153 of file metric_flat.C.

References Lorene::Metric::mp, Lorene::Metric::p_met_con, and triad.

## connect()

const Connection & Lorene::Metric_flat::connect | ( |  | ) | const

virtual

Returns the connection.

Reimplemented from Lorene::Metric.

Definition at line 175 of file metric_flat.C.

References Lorene::Metric::mp, Lorene::Metric::p_connect, and triad.

## cov()

const Sym_tensor & Lorene::Metric_flat::cov | ( |  | ) | const

virtual

Read-only access to the covariant representation.

Reimplemented from Lorene::Metric.

Definition at line 134 of file metric_flat.C.

References Lorene::Metric::mp, Lorene::Metric::p_met_cov, and triad.

## del_deriv()

void Lorene::Metric::del_deriv | ( |  | ) | const

protected inherited

Deletes all the derived quantities.

Definition at line 176 of file metric.C.

References p_connect, p_determinant, p_radial_vect, p_ricci_scal, and set_der_0x0().

## del_tensor_depend()

void Lorene::Metric::del_tensor_depend | ( |  | ) | const

protected inherited

Deletes all the derivative members of the `Tensor` contained in `tensor_depend` .

Those quantities had been previously calculated using `*this` .

Definition at line 197 of file metric.C.

References set_tensor_depend_0x0(), and tensor_depend.

## determinant()

const Scalar & Lorene::Metric_flat::determinant | ( |  | ) | const

virtual

Returns the determinant.

This determinant is stored as a `Scalar` although it a scalar density. To be a real scalar it must be divided by e.g. the determinant of a flat metric.

Reimplemented from Lorene::Metric.

Definition at line 214 of file metric_flat.C.

References Lorene::Metric::mp, and Lorene::Metric::p_determinant.

## get_mp()

const Map & Lorene::Metric::get_mp | ( |  | ) | const

inline inherited

Returns the mapping.

Definition at line 202 of file metric.h.

References Lorene::Map(), and mp.

## get_triad()

const Base_vect * Lorene::Metric_flat::get_triad | ( |  | ) | const

inline

Returns the vectorial basis (triad) on which the metric is defined.

Definition at line 309 of file metric.h.

References triad.

## operator=() [1/2]

void Lorene::Metric_flat::operator= | ( | const Metric_flat & | meti | ) |

Assignment to another Metric_flat.

Definition at line 112 of file metric_flat.C.

References Metric_flat(), Lorene::Metric::operator=(), and triad.

## operator=() [2/2]

void Lorene::Metric_flat::operator= | ( | const Sym_tensor & | tens | ) |

virtual

Assignment from a `Sym_tensor` .

In principle, this method should not be used for a `Metric_flat` .

Reimplemented from Lorene::Metric.

Definition at line 119 of file metric_flat.C.

## operator>>()

ostream & Lorene::Metric_flat::operator>> | ( | ostream & | ost | ) | const

protected virtual

Operator >> (virtual function called by the operator <<).

Reimplemented from Lorene::Metric.

Definition at line 241 of file metric_flat.C.

References triad.

## radial_vect()

const Vector & Lorene::Metric::radial_vect | ( |  | ) | const

virtual inherited

Returns the radial vector normal to a spherical slicing and pointing toward spatial infinity.

Definition at line 362 of file metric.C.

References p_radial_vect, Lorene::sqrt(), and Lorene::Scalar::std_spectral_base().

## ricci()

const Sym_tensor & Lorene::Metric::ricci | ( |  | ) | const

inherited

Returns the Ricci tensor (given by the `Connection`
`p_connect` ).

Definition at line 338 of file metric.C.

References connect(), and Lorene::Connection::ricci().

## ricci_scal()

const Scalar & Lorene::Metric_flat::ricci_scal | ( |  | ) | const

virtual

Returns the Ricci scalar.

Reimplemented from Lorene::Metric.

Definition at line 201 of file metric_flat.C.

References Lorene::Metric::mp, and Lorene::Metric::p_ricci_scal.

## sauve()

void Lorene::Metric_flat::sauve | ( | FILE * |  | ) | const

virtual

Save in a file.

Reimplemented from Lorene::Metric.

Definition at line 231 of file metric_flat.C.

## set_der_0x0()

void Lorene::Metric::set_der_0x0 | ( |  | ) | const

protected inherited

Sets to `0x0` all the pointers on derived quantities.

Definition at line 188 of file metric.C.

References p_connect, p_determinant, p_radial_vect, and p_ricci_scal.

## set_tensor_depend_0x0()

void Lorene::Metric::set_tensor_depend_0x0 | ( |  | ) | const

protected inherited

Sets all elements of `tensor_depend` to 0x0.

Definition at line 208 of file metric.C.

References tensor_depend.

## Member Data Documentation

## mp

const Map* const Lorene::Metric::mp

protected inherited

Reference mapping.

Definition at line 95 of file metric.h.

## p_connect

Connection* Lorene::Metric::p_connect

mutable protected inherited

Connection associated with the metric.

Definition at line 112 of file metric.h.

## p_determinant

Scalar* Lorene::Metric::p_determinant

mutable protected inherited

Pointer on the determinant.

Definition at line 132 of file metric.h.

## p_met_con

Sym_tensor* Lorene::Metric::p_met_con

mutable protected inherited

Pointer on the covariant representation.

Definition at line 105 of file metric.h.

## p_met_cov

Sym_tensor* Lorene::Metric::p_met_cov

mutable protected inherited

Pointer on the contravariant representation.

Definition at line 100 of file metric.h.

## p_radial_vect

Vector* Lorene::Metric::p_radial_vect

mutable protected inherited

Pointer to the radial vector normal to a spherical slicing and pointing toward spatial infinity.

Definition at line 125 of file metric.h.

## p_ricci_scal

Scalar* Lorene::Metric::p_ricci_scal

mutable protected inherited

Pointer on the Ricci scalar.

Remark: the Ricci tensor is stored in the connection (member `p_connect->p_ricci` ).

Definition at line 119 of file metric.h.

## tensor_depend

const Tensor* Lorene::Metric::tensor_depend[N_TENSOR_DEPEND]

mutable protected inherited

Pointer on the dependancies, that means the array contains pointers on all the `Tensor` whom derivative members have been calculated using `*this` .

Definition at line 139 of file metric.h.

## triad

const Base_vect* Lorene::Metric_flat::triad

protected

Vectorial basis (triad) with respect to which the components of the flat metric are defined.

Definition at line 270 of file metric.h.

The documentation for this class was generated from the following files:

- metric.h
- metric_flat.C